From da5bd272b6512cf70968497e7e4a6f1e2876bbc9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 17 2020 04:53:22 +0000
Subject: [PATCH 140/2232] Add const assert macro for some static checks


---

diff --git a/src/assert.rs b/src/assert.rs
new file mode 100644
index 0000000..6159ce6
--- /dev/null
+++ b/src/assert.rs
@@ -0,0 +1,30 @@
+pub struct True;
+pub struct False;
+
+pub trait ToBool {
+    type Bool: Sized;
+    const BOOL: Self::Bool;
+}
+
+impl ToBool for [(); 0] {
+    type Bool = False;
+    const BOOL: Self::Bool = False;
+}
+
+impl ToBool for [(); 1] {
+    type Bool = True;
+    const BOOL: Self::Bool = True;
+}
+
+macro_rules! bool {
+    ($e:expr) => {{
+        const EXPR: bool = $e;
+        <[(); EXPR as usize] as $crate::assert::ToBool>::BOOL
+    }};
+}
+
+macro_rules! const_assert {
+    ($e:expr) => {
+        const _: $crate::assert::True = bool!($e);
+    };
+}
diff --git a/src/lib.rs b/src/lib.rs
index 48c3b72..3744bda 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -349,6 +349,9 @@
 
 extern crate link_cplusplus;
 
+#[macro_use]
+mod assert;
+
 mod cxx_string;
 mod error;
 mod gen;

